<?php
/*
Extension Name: pictcha
Extension Url: http://utyp.net/lab.php
Description: Add pictcha validation to the registration form.
Version: 1.0
Author: gilemon
Author Url: http://utyp.net/
*/

// Set dictionary definitions.
$Context->SetDefinition('pictcha.Error.Config', 'The pictcha extension is not configured properly. Please <a href="mailto:' . $Configuration['SUPPORT_EMAIL'] . '">contact the admin</a> and report this problem.');
$Context->SetDefinition('pictcha.Error.Incorrect', 'The pictcha was not entered correctly. Are you a robot?');
$Context->SetDefinition('pictcha.Error.NoKey', 'You must enter both a public key and a private key to use pictcha.');


// Define the path to the pictcha code.
define('pictcha_PATH', dirname(__FILE__) . DIRECTORY_SEPARATOR . 'pictcha-php-1.0');

// Avoid an error message if the extension hasn't been set up yet.
if ( !isset($Context->Configuration['pictcha.ApplyForm']) ) {
	$Context->Configuration['pictcha.ApplyForm'] = 0;
}

if ( ('people.php' == $Context->SelfUrl)
	&& in_array(ForceIncomingString('PostBackAction', ''), array('ApplyForm', 'Apply'))
	&& $Context->Configuration['pictcha.ApplyForm'] ) {

	// Include the pictcha library.
	if (!function_exists('get_picture')) {
		//echo pictcha_PATH . DIRECTORY_SEPARATOR . 'pictcha.php';
		include(pictcha_PATH . DIRECTORY_SEPARATOR . 'pictcha.php');
	}

	// Add a custom stylesheet to make sure pictcha fits in the app form.
	$Head->AddStyleSheet('extensions/pictcha/pictcha.css', 'screen', 998);
	$Head->AddStyleSheet($Context->StyleUrl.'pictcha.css', 'screen', 999);

	function pictcha_RenderCaptcha(&$ApplyForm)
	{
		// Assume white is the default theme.
		$theme = isset($ApplyForm->Context->Configuration['pictcha.Theme']) ?
			$ApplyForm->Context->Configuration['pictcha.Theme'] : 'white';

		// Assume English is the default language.
		$lang = isset($ApplyForm->Context->Configuration['pictcha.Language']) ?
			$ApplyForm->Context->Configuration['pictcha.Language'] : 'en';

		// Add the script that configures the pictcha box.
		echo "
<script>
var pictchaOptions = {
	theme : '$theme',
	lang : '$lang' 
};
function openFrameless(){
	var windowW=400 // wide
	var windowH=500 // high
	// set the screen position where the popup should appear
	var windowX = (screen.width-windowW)/2;
	var windowY = (screen.height-windowH)/2;
	// set the url of the page to show in the popup
	var urlPop = \"http://utyp.net/pictcha-help.html\"
	// set the title of the page
	var title =  \"PICTCHA Form Spam Protection - HELP\"
	// set this to true if the popup should close
	// upon leaving the launching page; else, false
	var autoclose = true
	s = \"width=\"+windowW+\",height=\"+windowH;
	var beIE = document.all?true:false
	  if (beIE){
		NFW = window.open(\"\",\"popFrameless\",'toolbar=0,status=0,filemenu=0,scrolling=0,left=0,top=0,'+s) 
		NFW.blur()
		window.focus()       
		NFW.resizeTo(windowW,windowH)
		NFW.moveTo(windowX,windowY)
		var frameString=\"\"+
	\"<html>\"+
	\"<head>\"+
	\"<title>\"+title+\"</title>\"+
	\"</head>\"+
	\"<frameset rows='*,0' framespacing=0 border=0 frameborder=0>\"+
	\"<frame name='top' src='\"+urlPop+\"' scrolling=auto>\"+
	\"<frame name='bottom' src='about:blank' scrolling='no'>\"+
	\"</frameset>\"+
	\"</html>\"
		NFW.document.open();
		NFW.document.write(frameString)
		NFW.document.close()
	  } else {
		NFW=window.open(urlPop,\"popFrameless\",'toolbar=0,status=0,filemenu=0,scrolling=0,left=0,top=0,'+s) 
		NFW.blur()
		window.focus() 
		NFW.resizeTo(windowW,windowH)
		NFW.moveTo(windowX,windowY)
	  }   
	  NFW.focus()   
	  if (autoclose){
		window.onunload = function(){NFW.close()}
	  }
	}
</script>\n";

		// Output the pictcha box itself.
		$pictcha = new pictcha();
		$arra =  $pictcha->get_picture($ApplyForm->Context->Configuration['pictcha.Level']);
		$pictureSession = $arra[0];
		$pictureUrl = $arra[1];
		echo '<input type="hidden" name="pictureUrl" id="pictureUrl" value="'.$pictureSession.'">';
		echo '<br><IMG SRC='.$pictureUrl.'>';
		echo '<br>Question:<a href="javascript:openFrameless()">What</a>\'s this picture?<br/>';
		echo '<noscript> <br> Question: <a href="http://utyp.net/pictcha-help.html" target="pictcha">What</a>\'s this picture?<br> </noscript>';
		echo '<input id="inputOr" type="text" maxlength="25" size="15" name="inputOr"/>';
		//echo get_picture($ApplyForm->Context->Configuration['pictcha.Level']);
	}
	$Context->AddToDelegate('ApplyForm', 'PostInputsRender', 'pictcha_RenderCaptcha');
 
	function pictcha_CheckCaptcha(&$ApplyForm)
	{
		$pictcha = new pictcha();
		if(!$pictcha->verify(ForceIncomingString('inputOr', ''), ForceIncomingString('pictureUrl', '')))
		{
			echo ForceIncomingString('inputOr', '');
			echo ForceIncomingString('pictureUrl', '');
			$ApplyForm->Context->WarningCollector->Add($ApplyForm->Context->GetDefinition('pictcha.Error.Incorrect'));
		}
	}
	$Context->AddToDelegate('ApplyForm', 'PreCreateUser', 'pictcha_CheckCaptcha');
}
?>
